/*
  yasep/index.js
  created dim. sept. 11 03:10:21 CEST 2011

  contains all the JS code that was in the index.html before
*/

var js_list=[
 'gui-js/lang',
 'gui-js/XHR',
 'core-js/txt_int',
 'core-js/base66s',
 'gui-js/cookies',
 'gui-js/ygwm',
 'gui-js/ygwm-colors',
 'gui-js/ygwm-options',
 'gui-js/ygwm-winlist',
 'gui-js/menu',
 'gui-js/winman',
 'ISM/ISM', // ISM is pointed to by core-js/yasep_opcodes.js:Y.NewOpcode

 'core-js/yasep_forms',
 'core-js/yasep_fields',
 'core-js/yasep_flags',
 'core-js/yasep_opcodes',
 'core-js/yasep_groups',
 'core-js/yasep_conditions',

// 'core-js/group_eu', // parts of the future simulator
 'core-js/group_ctl',
 'core-js/group_asu',
 'core-js/group_rop2',
 'core-js/group_shl',
 'core-js/group_ie',
 'core-js/group_mul',
 'core-js/group_rsv',

 'core-js/yasep_pseudo',
 'core-js/yasep_asm',
 'core-js/yasep_disasm',

 'tool/test_opcodes',
 'doc/opcode_map',
 'tool/asm',
 'doc/doc',
 'doc/forms',
 'doc/asm',
 'doc/16-32'
 //, 'test/template'
];
for (i in js_list)
  document.write('<script type="text/javascript" src="'+js_list[i]+'.js"></'+'script>\n');

var window_introduction, window_plop, rainbow_x=5;

function start_ygwm() {
//  bodydiv=document.getElementById('bodydiv');
//  bodydiv.innerHTML="@"+window.location.hash+"@";
//  document.getElementById('bodydiv').innerHTML=winman.dump_keys;

  document.getElementById('div_start_ygwm').style.display="none";

/* first, create the menu, then the winlist, then apps and finally the windows */
  init_obj=[ menu, winlist, LANG, test_opcodes, OpcodeTable, asmwin, DOC_GEN /*, template*/ ];
  for (var o in init_obj)
    init_obj[o].init_obj();

/* finally create the windows */
  window_introduction = ygwm.new_window(
    "Welcome!",
    document.getElementById('IntroductionWindow'), null,
    Math.ceil((document.body.clientWidth*2)/3), 500,
    Math.ceil( document.body.clientWidth/6), 41, false, true, true, false, false, "docStyle");

// hide the warning
  document.getElementById('BigRedWarning').style.display="none";

/* 1) not reliable - browser or computer can crash
   2) not supported by opera
 but still useful to save the cookies !
  window.onbeforeunload = function(e){
    return;
  }*/

// examine the address and extract the key+arguments
  var l=window.location.hash;
  if (l.indexOf("#!")==0)
    winman.innerLink(l.slice(2));
}

function Intro_onchange(){
  if (document.form_start_ygwm.no_intro.checked==true) {
    skip_intro=1;
    save_cookies();
  }
  else {
    skip_intro=0;
    save_cookies();
  }
}

// called by <body onload>
function body_start() {
  init_cookies();
  if (skip_intro==1){
    document.getElementById('BigRedWarning').style.display="";
    document.form_start_ygwm.no_intro.checked=true;
    start_ygwm();
  }
  else
    document.form_start_ygwm.no_intro.checked==false;
  document.form_start_ygwm.no_intro.onchange=Intro_onchange;

  // only display the button when the whole page is loaded !
  // otherwise it can create a race condition, the user could click
  // when it is not fully loaded
  document.getElementById('hiddenform').style.display="";
}
