/* yasep/lang.js
created 20110909 by whygee@f-cpu.org
20110912 : objectified

Some definitions and general utilities for managing the languages.
LANG is also read/written by yasep/cookies.js
*/

LANG={
  LANGS:["en", "fr"],     //, "es"],
  LANGUAGES:["english", "français"],
  LANG:0, // changed when reading the cookies
  // LANG could become any large integer number, as it gets encoded/decoded in base66.

  langPick:null,

  change_lang: function(i){
    if (i<0)
      i=0;
    if (i>=LANG.LANGS.length)
      i=LANG.LANGS.length-1;

    LANG.LANG=i;
    l=LANG.LANGS[i];
    LANG.langPick.firstChild.innerHTML='<img src="logos/flag_'+l+'.gif">';
    save_cookies();
  },

  // To be called AFTER menu.create() AND init_cookies() !
  init_obj: function() {
    // Create the language picker menu
    var l=menu.mainMenuItem('LNG',"R");
    LANG.langPick=l;
    l.title="Switch language";
    for (var i in LANG.LANGS)
      menu.subMenuItem(l,'<img src="logos/flag_'+LANG.LANGS[i]+'.gif">',
         function(i){return function(){LANG.change_lang(i)};}(i) ).title=LANG.LANGUAGES[i];

    // set to the current language logo 
    LANG.change_lang(LANG.LANG);
  }
}
